package java.util.concurrent;

import java.util.Collection;
import java.util.List;

public interface ExecutorService extends Executor
{
    public abstract void shutdown();
    
    public abstract List<Runnable> shutdownNow();
    
    public abstract boolean isShutdown();
    
    public abstract boolean isTerminated();
    
    public abstract boolean awaitTermination(long p0, TimeUnit p1) throws InterruptedException;
    
    public abstract <T> Future<T> submit(Callable<T> p0);
    
    public abstract <T> Future<T> submit(Runnable p0, T p1);
    
    public abstract Future<?> submit(Runnable p0);
    
    public abstract <T> List<Future<T>> invokeAll(Collection<? extends Callable<T>> p0) throws InterruptedException;
    
    public abstract <T> List<Future<T>> invokeAll(Collection<? extends Callable<T>> p0, long p1, TimeUnit p2) throws InterruptedException;
    
    public abstract <T> T invokeAny(Collection<? extends Callable<T>> p0) throws InterruptedException, ExecutionException;
    
    public abstract <T> T invokeAny(Collection<? extends Callable<T>> p0, long p1, TimeUnit p2) throws InterruptedException, ExecutionException, TimeoutException;
}
